switch (quality)
{
	case 0: // Low
		settingsImageSampler.DmcMinSubdivs = 1;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 8 : 16;
		settingsImageSampler.DmcThreshold = 0.1f;
		settingsImageSampler.ProgressiveMinSubdivs = 1;
		settingsImageSampler.ProgressiveMaxSubdivs = 8;
		settingsImageSampler.ProgressiveThreshold = 0.1f;

		settingsRTEngine.NoiseThreshold = 0.1f;
		settingsRTEngine.MaxSampleLevel = 256;

		settingsLightCache.Subdivs = 600;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 2;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 30;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = -3;
		settingsIrradianceMap.InterpSamples = 20;
		settingsIrradianceMap.ColorThreshold = 0.4f;
		settingsIrradianceMap.NormalThreshold = 0.3f;
		settingsIrradianceMap.DistanceThreshold = 0.1f;
		break;
	case 1: // Low+
		settingsImageSampler.DmcMinSubdivs = 1;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 12 : 24;
		settingsImageSampler.DmcThreshold = 0.08f;
		settingsImageSampler.ProgressiveMinSubdivs = 1;
		settingsImageSampler.ProgressiveMaxSubdivs = 12;
		settingsImageSampler.ProgressiveThreshold = 0.08f;

		settingsRTEngine.NoiseThreshold = 0.08f;
		settingsRTEngine.MaxSampleLevel = 576;

		settingsLightCache.Subdivs = 700;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 2;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 40;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = -2;
		settingsIrradianceMap.InterpSamples = 20;
		settingsIrradianceMap.ColorThreshold = 0.4f;
		settingsIrradianceMap.NormalThreshold = 0.3f;
		settingsIrradianceMap.DistanceThreshold = 0.1f;
		break;
	case 3: // Medium+
		settingsImageSampler.DmcMinSubdivs = 1;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 42 : 84;
		settingsImageSampler.DmcThreshold = 0.02f;
		settingsImageSampler.ProgressiveMinSubdivs = 1;
		settingsImageSampler.ProgressiveMaxSubdivs = 42;
		settingsImageSampler.ProgressiveThreshold = 0.02f;

		settingsRTEngine.NoiseThreshold = 0.02f;
		settingsRTEngine.MaxSampleLevel = 7056;

		settingsLightCache.Subdivs = 1000;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 2;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 60;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = -1;
		settingsIrradianceMap.InterpSamples = 40;
		settingsIrradianceMap.ColorThreshold = 0.3f;
		settingsIrradianceMap.NormalThreshold = 0.2f;
		settingsIrradianceMap.DistanceThreshold = 0.2f;
		break;
	case 4: // High
		settingsImageSampler.DmcMinSubdivs = 2;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 64 : 128;
		settingsImageSampler.DmcThreshold = 0.01f;
		settingsImageSampler.ProgressiveMinSubdivs = 2;
		settingsImageSampler.ProgressiveMaxSubdivs = 64;
		settingsImageSampler.ProgressiveThreshold = 0.01f;

		settingsRTEngine.NoiseThreshold = 0.01f;
		settingsRTEngine.MaxSampleLevel = 16384;

		settingsLightCache.Subdivs = 1500;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 3;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 70;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = 0;
		settingsIrradianceMap.InterpSamples = 50;
		settingsIrradianceMap.ColorThreshold = 0.3f;
		settingsIrradianceMap.NormalThreshold = 0.1f;
		settingsIrradianceMap.DistanceThreshold = 0.3f;
		break;
	case 5: // High+
		settingsImageSampler.DmcMinSubdivs = 2;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 100 : 200;
		settingsImageSampler.DmcThreshold = 0.005f;
		settingsImageSampler.ProgressiveMinSubdivs = 2;
		settingsImageSampler.ProgressiveMaxSubdivs = 100;
		settingsImageSampler.ProgressiveThreshold = 0.005f;

		settingsRTEngine.NoiseThreshold = 0.005f;
		settingsRTEngine.MaxSampleLevel = 40000;

		settingsLightCache.Subdivs = 2000;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 4;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 80;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = 0;
		settingsIrradianceMap.InterpSamples = 50;
		settingsIrradianceMap.ColorThreshold = 0.2f;
		settingsIrradianceMap.NormalThreshold = 0.1f;
		settingsIrradianceMap.DistanceThreshold = 0.4f;
		break;
	default: // Medium
		settingsImageSampler.DmcMinSubdivs = 1;
		settingsImageSampler.DmcMaxSubdivs = isCpu ? 20 : 40;
		settingsImageSampler.DmcThreshold = 0.04f;
		settingsImageSampler.ProgressiveMinSubdivs = 1;
		settingsImageSampler.ProgressiveMaxSubdivs = 20;
		settingsImageSampler.ProgressiveThreshold = 0.04f;

		settingsRTEngine.NoiseThreshold = 0.04f;
		settingsRTEngine.MaxSampleLevel = 1600;

		settingsLightCache.Subdivs = 800;
		settingsLightCache.SampleSize = 0.01f;
		settingsLightCache.RetraceThreshold = 2;
		settingsLightCache.WorldScale = false;

		settingsIrradianceMap.Subdivs = 50;
		settingsIrradianceMap.MinRate = -3;
		settingsIrradianceMap.MaxRate = -1;
		settingsIrradianceMap.InterpSamples = 30;
		settingsIrradianceMap.ColorThreshold = 0.4f;
		settingsIrradianceMap.NormalThreshold = 0.2f;
		settingsIrradianceMap.DistanceThreshold = 0.1f;
		break;
}
